//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private ElephantTracker10[] cacheElephantTracker10 = null;

        private static ElephantTracker10 checkElephantTracker10 = new ElephantTracker10();

        /// <summary>
        /// Elephant Tracks Indicator Showing Buying (Green) and Selling (Red) Pressure Only for Size of Trades Falling in Range Specified
        /// </summary>
        /// <returns></returns>
        public ElephantTracker10 ElephantTracker10(int lthreshold, bool showText, bool useVol, int uthreshold)
        {
            return ElephantTracker10(Input, lthreshold, showText, useVol, uthreshold);
        }

        /// <summary>
        /// Elephant Tracks Indicator Showing Buying (Green) and Selling (Red) Pressure Only for Size of Trades Falling in Range Specified
        /// </summary>
        /// <returns></returns>
        public ElephantTracker10 ElephantTracker10(Data.IDataSeries input, int lthreshold, bool showText, bool useVol, int uthreshold)
        {
            if (cacheElephantTracker10 != null)
                for (int idx = 0; idx < cacheElephantTracker10.Length; idx++)
                    if (cacheElephantTracker10[idx].Lthreshold == lthreshold && cacheElephantTracker10[idx].ShowText == showText && cacheElephantTracker10[idx].UseVol == useVol && cacheElephantTracker10[idx].Uthreshold == uthreshold && cacheElephantTracker10[idx].EqualsInput(input))
                        return cacheElephantTracker10[idx];

            lock (checkElephantTracker10)
            {
                checkElephantTracker10.Lthreshold = lthreshold;
                lthreshold = checkElephantTracker10.Lthreshold;
                checkElephantTracker10.ShowText = showText;
                showText = checkElephantTracker10.ShowText;
                checkElephantTracker10.UseVol = useVol;
                useVol = checkElephantTracker10.UseVol;
                checkElephantTracker10.Uthreshold = uthreshold;
                uthreshold = checkElephantTracker10.Uthreshold;

                if (cacheElephantTracker10 != null)
                    for (int idx = 0; idx < cacheElephantTracker10.Length; idx++)
                        if (cacheElephantTracker10[idx].Lthreshold == lthreshold && cacheElephantTracker10[idx].ShowText == showText && cacheElephantTracker10[idx].UseVol == useVol && cacheElephantTracker10[idx].Uthreshold == uthreshold && cacheElephantTracker10[idx].EqualsInput(input))
                            return cacheElephantTracker10[idx];

                ElephantTracker10 indicator = new ElephantTracker10();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Lthreshold = lthreshold;
                indicator.ShowText = showText;
                indicator.UseVol = useVol;
                indicator.Uthreshold = uthreshold;
                Indicators.Add(indicator);
                indicator.SetUp();

                ElephantTracker10[] tmp = new ElephantTracker10[cacheElephantTracker10 == null ? 1 : cacheElephantTracker10.Length + 1];
                if (cacheElephantTracker10 != null)
                    cacheElephantTracker10.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheElephantTracker10 = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Elephant Tracks Indicator Showing Buying (Green) and Selling (Red) Pressure Only for Size of Trades Falling in Range Specified
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ElephantTracker10 ElephantTracker10(int lthreshold, bool showText, bool useVol, int uthreshold)
        {
            return _indicator.ElephantTracker10(Input, lthreshold, showText, useVol, uthreshold);
        }

        /// <summary>
        /// Elephant Tracks Indicator Showing Buying (Green) and Selling (Red) Pressure Only for Size of Trades Falling in Range Specified
        /// </summary>
        /// <returns></returns>
        public Indicator.ElephantTracker10 ElephantTracker10(Data.IDataSeries input, int lthreshold, bool showText, bool useVol, int uthreshold)
        {
            return _indicator.ElephantTracker10(input, lthreshold, showText, useVol, uthreshold);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Elephant Tracks Indicator Showing Buying (Green) and Selling (Red) Pressure Only for Size of Trades Falling in Range Specified
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ElephantTracker10 ElephantTracker10(int lthreshold, bool showText, bool useVol, int uthreshold)
        {
            return _indicator.ElephantTracker10(Input, lthreshold, showText, useVol, uthreshold);
        }

        /// <summary>
        /// Elephant Tracks Indicator Showing Buying (Green) and Selling (Red) Pressure Only for Size of Trades Falling in Range Specified
        /// </summary>
        /// <returns></returns>
        public Indicator.ElephantTracker10 ElephantTracker10(Data.IDataSeries input, int lthreshold, bool showText, bool useVol, int uthreshold)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ElephantTracker10(input, lthreshold, showText, useVol, uthreshold);
        }
    }
}
#endregion
